//
//  APMAction.h
//  APMServices
//
//  Created by Vincent Ducastel on 02/10/2014.
//  Copyright (c) 2015 Moonmiles. All rights reserved.
//

#import "APMModel.h"

@interface APMAction : APMModel<NSCopying>

@property(nonatomic, strong) NSString *actionName;
@property(nonatomic, strong) NSString *classID;
@property(nonatomic, strong) NSArray *tagLabels;
@property(nonatomic, strong) NSArray *properties;
@property(nonatomic, strong) NSArray *deeplinkUrls;

-(id)initWithAction:(NSString*)actionName;
-(id)initWithAction:(NSString*)actionName withLabel:(NSString*)tagLabel forClassID:(NSString*)classID;
-(id)initWithAction:(NSString*)actionName withLabel:(NSString*)tagLabel withProperty:(NSString*)property forClassID:(NSString*)classID;
-(id)initWithAction:(NSString*)actionName withLabels:(NSArray*)tagLabels withProperties:(NSArray*)properties forClassID:(NSString*)classID;

-(void)setDeeplinkUrl:(NSString *)deeplinkUrl;

-(NSString*)tagIDForLabel:(NSString*)tagLabel;
-(NSString*)tagIDMax;
-(BOOL)isValid;

@end
