//
//  APMAnimationUtils.h
//  APMServices
//
//  Created by Vincent Ducastel on 02/07/2015.
//  Copyright (c) 2015 Moonmiles. All rights reserved.
//

@interface APMAnimationUtils : NSObject

+(void)animateScaleInAndScaleOut:(UIView*)view parentView:(UIView*)parentView duration:(NSTimeInterval)duration scaleIn:(CGFloat)scaleIn onAnimationEnd:(void (^)(void))onAnimationEnd;
+(void)animateFade:(UIView*)view parentView:(UIView*)parentView duration:(NSTimeInterval)duration from:(CGFloat)from to:(CGFloat)to completion:(void (^)(BOOL finished))completion;
+(void)animateScaleInfinite:(UIView*)view duration:(NSTimeInterval)duration toScale:(CGFloat)toScale;
+(void)animationFromScaleAndFadeView:(UIView*)view
                      withParentView:(UIView*)parentView
                            duration:(NSTimeInterval)duration
                           fromScale:(CGFloat)fromScale
                           fromAlpha:(CGFloat)fromAlpha toAlpha:(CGFloat)toAlpha;
+(void)showLoader:(UIActivityIndicatorView*)loader completion:(void (^)(void))completion;
+(void)hideLoader:(UIActivityIndicatorView*)loader completion:(void (^)(void))completion;
+(void)showView:(UIView*)view completion:(void (^)(void))completion;
+(void)hideView:(UIView*)view completion:(void (^)(void))completion;
+(void)animateSelectCell:(UIView*)cell selectedColor:(UIColor*)selectedColor unselectedColor:(UIColor*)unselectedColor completion:(void (^)(void))completion;

@end
