//
//  APMBurn.h
//  APMServices
//
//  Created by Vincent Ducastel on 15/05/2014.
//  Copyright (c) 2015 Moonmiles. All rights reserved.
//

#import "APMModel.h"
#import "APMImagesUtils.h"

@interface APMBurn : APMModel<NSCoding, NSCopying, APMMediaProtocol>
{
    NSString *_media;
    UIImage *_imageMedia;
    NSInteger _countImageMediaLoad;
    BOOL _isImageMediaLoading;
}

@property (nonatomic, assign) NSInteger burnID;
@property (nonatomic, strong) NSDate *burnDate;
@property (nonatomic, strong) NSString *partnerLabel;
@property (nonatomic, strong) NSString *label;
@property (nonatomic, strong) NSString *content;
@property (nonatomic, assign) NSInteger value;
@property (nonatomic, assign) NSInteger type;
@property (nonatomic, strong) NSString *code;
@property (nonatomic, strong) NSString *storeID; //storeID only used on app's miles app but commented
@property (nonatomic, strong) NSString *apmScheme; //apmScheme not use on iOS
@property (nonatomic, strong) NSString *urlScheme; //For a gift type URL (startActivity with (urlScheme + code) or only (code)
@property (nonatomic, strong) NSString *conditions;
@property (nonatomic, assign) NSInteger status;
@property (nonatomic, strong) NSDate *issueDate;
@property (nonatomic, strong) NSDate *expirationDate;

@property (nonatomic, assign) NSInteger nature;

-(id)initWithJSONObject:(NSDictionary*)jsonObject;
-(void)use;
-(void)resetImageMediaLoading;

-(NSString*)issuedDateString;
-(NSString*)expirationDateString;
-(NSString*)burnDateString;

@end
