//
//  APMChallenge.h
//  APMServices
//
//  Created by Vincent Ducastel on 09/01/2017.
//  Copyright © 2017 Moonmiles. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "APMModel.h"

#define APM_K_CHALLENGE_ID                      @"id"
#define APM_K_CHALLENGE_LABEL                   @"label"
#define APM_K_CHALLENGE_DESC                    @"desc"
#define APM_K_CHALLENGE_CURRENT_STEP            @"currentStep"
#define APM_K_CHALLENGE_TOTAL_STEP              @"totalStep"
#define APM_K_CHALLENGE_VALUE                   @"value"
#define APM_K_CHALLENGE_IS_SUPER                @"isSuper"
#define APM_K_CHALLENGE_GENEROSITIES            @"generosities"
#define APM_K_CHALLENGE_TRIGGERED_AT            @"triggeredAt"
#define APM_K_CHALLENGE_IS_RECENTLY_COMPLETED   @"isRecentlyCompleted"

@interface APMChallenge : APMModel<NSCoding, NSCopying>

@property(nonatomic, assign) NSInteger identifiant;
@property(nonatomic, strong) NSString *label;
@property(nonatomic, strong) NSString *desc;
@property(nonatomic, assign) NSInteger currentStep;
@property(nonatomic, assign) NSInteger totalStep;
@property(nonatomic, assign) NSInteger value;
@property(nonatomic, assign) BOOL isSuper;
@property(nonatomic, strong) NSMutableArray *generosities;
@property(nonatomic, strong) NSDate *triggeredAt;

//Local
@property(nonatomic, assign) BOOL isRecentlyCompleted;

-(instancetype)initWithJSONObject:(NSDictionary*)jsonObject;
-(BOOL)isPlayable;
-(BOOL)isDone;
-(void)updateWithChallenge:(APMChallenge*)challenge;

@end
