//
//  APMGenerosity.h
//  APMServices
//
//  Created by Vincent Ducastel on 01/10/2014.
//  Copyright (c) 2015 Moonmiles. All rights reserved.
//

#import "APMModel.h"

@class APMRule;
@class APMIdsFromTagId;

#define APM_GENEROSITY_ELIGIBILITY_OFF 0
#define APM_GENEROSITY_ELIGIBILITY_ON 1

@interface APMGenerosity : APMModel<NSCoding, NSCopying>

@property (nonatomic, assign) NSInteger generosityID;
@property(nonatomic, strong) NSString *generosityMsg;
@property(nonatomic, assign) NSInteger generosityValue;
@property(nonatomic, assign) NSInteger generosityFrequence;
@property(nonatomic, strong) NSString *tagID;
@property(nonatomic, strong) NSString *tagLabel;
@property(nonatomic, strong) NSString *actionName;
@property(nonatomic, strong) NSString *classID;
@property(nonatomic, strong) NSDate* triggedAt;
@property(nonatomic, assign) double offset;
@property(nonatomic, assign) NSInteger generosityType;
@property(nonatomic, strong) NSString *deeplinkUrl;
@property(nonatomic, strong) NSString *frequency;
@property(nonatomic, strong) NSArray *rules;
@property(nonatomic, assign) NSInteger eligibility;

-(id)initWithJSONObject:(NSDictionary*)jsonObject;
-(BOOL)isActived;
-(BOOL)isPlayable;
-(BOOL)isEligible;

-(APMIdsFromTagId*)isGenerosityMatchesTagId:(NSString*)tagId properties:(NSDictionary*)properties;

-(BOOL)isPlayableForChallengeWithTagId:(NSString*)tagId;
-(BOOL)isPlayableForTrophyWithTagId:(NSString*)tagId;
-(BOOL)updateTriggedAtIfMatchesWithTagId:(NSString*)tagId ruleId:(NSInteger)ruleId;

@end
