//
//  APMImagesUtils.h
//  APMServices
//
//  Created by Vincent Ducastel on 10/08/2015.
//  Copyright (c) 2015 Moonmiles. All rights reserved.
//

@class APMGift;
@class APMAd;
@class APMBurn;
@class APMPartner;

@protocol APMMediaProtocol

-(NSString*)media;
-(void)setMedia:(NSString*)media;

-(UIImage*)imageMedia;
-(void)setImageMedia:(UIImage*)imageMedia;

-(NSInteger)countImageMediaLoad;
-(void)setCountImageMediaLoad:(NSInteger)countImageMediaLoad;

-(BOOL)isImageMediaLoading;
-(void)setIsImageMediaLoading:(BOOL)isImageMediaLoading;

@end

@protocol APMLargeMediaProtocol

-(NSString*)largeMedia;
-(void)setLargeMedia:(NSString*)largeMedia;

-(UIImage*)imageLargeMedia;
-(void)setImageLargeMedia:(UIImage*)imageLargeMedia;

-(NSInteger)countImageLargeMediaLoad;
-(void)setCountImageLargeMediaLoad:(NSInteger)countImageLargeMediaLoad;

-(BOOL)isImageLargeMediaLoading;
-(void)setIsImageLargeMediaLoading:(BOOL)isImageLargeMediaLoading;

@end

typedef enum APMImagesUtilsOptions : NSUInteger {
    APMImagesUtilsOptionsNone = 0,
    APMImagesUtilsOptionsFilterGrayscale = 1 <<  0
} APMImagesUtilsOptions;

@interface APMImagesUtils : NSObject

+(void)buildMedia:(id<APMMediaProtocol>)mediaProtocol
        imageView:(UIImageView*)imageView tagImageView:(NSInteger)tagImageView;

+(void)buildMedia:(id<APMMediaProtocol>)mediaProtocol
        imageView:(UIImageView*)imageView tagImageView:(NSInteger)tagImageView
           loader:(UIActivityIndicatorView*)loader tagLoader:(NSInteger)tagLoader;

+(void)buildMedia:(id<APMMediaProtocol>)mediaProtocol
        imageView:(UIImageView*)imageView tagImageView:(NSInteger)tagImageView
           loader:(UIActivityIndicatorView*)loader tagLoader:(NSInteger)tagLoader
        logoEmpty:(UIView*)logoEmpty tagLogoEmpty:(NSInteger)tagLogoEmpty
        tableView:(id)tableView indexPath:(NSIndexPath*)indexPath;

+(void)buildMedia:(id<APMMediaProtocol>)mediaProtocol
        imageView:(UIImageView*)imageView tagImageView:(NSInteger)tagImageView
           loader:(UIActivityIndicatorView*)loader tagLoader:(NSInteger)tagLoader
        logoEmpty:(UIView*)logoEmpty tagLogoEmpty:(NSInteger)tagLogoEmpty
        tableView:(id)tableView indexPath:(NSIndexPath*)indexPath
        fromScale:(CGFloat)fromScale
        fromAlpha:(CGFloat)fromAlpha toAlpha:(CGFloat)toAlpha
         duration:(NSTimeInterval)duration
          options:(APMImagesUtilsOptions)options;

+(void)buildLargeMedia:(id<APMLargeMediaProtocol>)largeMediaProtocol
             imageView:(UIImageView*)imageView tagImageView:(NSInteger)tagImageView
                loader:(UIActivityIndicatorView*)loader tagLoader:(NSInteger)tagLoader
             logoEmpty:(UIView*)logoEmpty tagLogoEmpty:(NSInteger)tagLogoEmpty
             tableView:(id)tableView indexPath:(NSIndexPath*)indexPath;

+(void)buildLargeMedia:(id<APMLargeMediaProtocol>)largeMediaProtocol
             imageView:(UIImageView*)imageView tagImageView:(NSInteger)tagImageView
                loader:(UIActivityIndicatorView*)loader tagLoader:(NSInteger)tagLoader
             logoEmpty:(UIView*)logoEmpty tagLogoEmpty:(NSInteger)tagLogoEmpty
             tableView:(id)tableView indexPath:(NSIndexPath*)indexPath
             fromScale:(CGFloat)fromScale
             fromAlpha:(CGFloat)fromAlpha toAlpha:(CGFloat)toAlpha
              duration:(NSTimeInterval)duration
               options:(APMImagesUtilsOptions)options;

+(UIImage*)generateBarcodeImageWithValue:(NSString*)value;
+(UIImage*)generateQRCodeImageWithValue:(NSString*)value;

@end
