//
//  APMLOTAnimation.h
//  APMServices
//
//  APMLOTAnimation --> External resource for lottie and image. Keep the name for retrocompatibility
//
//  Created by Vincent Ducastel on 09/01/2017.
//  Copyright © 2017 Moonmiles. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "APMModel.h"

#define APM_EXTERNAL_RES_TYPE_IMAGE 1
#define APM_EXTERNAL_RES_TYPE_LOTTIE 2

//Common
#define APM_K_EXTERNAL_RES_URL             @"url"
#define APM_K_EXTERNAL_RES_KEY             @"key"
#define APM_K_EXTERNAL_RES_VERSION         @"version"
#define APM_K_EXTERNAL_RES_TYPE            @"type"

//Type : Lottie
#define APM_K_EXTERNAL_RES_JSON            @"json"

//Type : Image
#define APM_K_EXTERNAL_RES_IMAGE            @"image"
#define APM_K_EXTERNAL_RES_DATA_IMAGE       @"dataImage"

@interface APMLOTAnimation : APMModel<NSCoding, NSCopying>

//Common
@property(nonatomic, strong) NSString *url;
@property(nonatomic, strong) NSString *key;
@property(nonatomic, assign) NSInteger version;
@property(nonatomic, assign) NSInteger type; //Type : 0 == Lottie, 1 == image

//Type : Lottie
@property(nonatomic, strong) NSDictionary *json;

//Type : Image
@property(nonatomic, strong) UIImage *image;
@property(nonatomic, strong) NSData *dataImage;

-(instancetype)initWithJSONObject:(NSDictionary*)jsonObject;
-(void)loadWithSuccess:(void (^)(APMLOTAnimation *lotAnimation))success failure:(void (^)(NSError* error))failure;

-(void)resetAnimationIfNeeded:(APMLOTAnimation*)animation;
-(void)loadData;

@end
