//
//  APMProduct.h
//  APMServices
//
//  Created by Vincent Ducastel on 11/09/2018.
//  Copyright (c) 2018 Moonmiles. All rights reserved.
//

#import "APMModel.h"

#define APM_K_PRODUCT_ID                @"id"
#define APM_K_PRODUCT_EAN               @"ean"
#define APM_K_PRODUCT_REF               @"ref"
#define APM_K_PRODUCT_URL               @"url"
#define APM_K_PRODUCT_LANG              @"lang"
#define APM_K_PRODUCT_TITLE             @"title"
#define APM_K_PRODUCT_PRICE             @"price"
#define APM_K_PRODUCT_DISCOUNTED_PRICE  @"discountedPrice"
#define APM_K_PRODUCT_DISCOUNT          @"discount"
#define APM_K_PRODUCT_CURRENCY          @"currency"
#define APM_K_PRODUCT_DESCRIPTION       @"description"
#define APM_K_PRODUCT_SHORT_DESCRIPTION @"shortDescription"
#define APM_K_PRODUCT_RATING            @"rating"
#define APM_K_PRODUCT_RATING_SCALE      @"ratingScale"
#define APM_K_PRODUCT_COLOR_ID          @"colorId"
#define APM_K_PRODUCT_SIZE_ID           @"sizeId"
#define APM_K_PRODUCT_AVAILABILITY      @"availability"
#define APM_K_PRODUCT_VIDEOS            @"videos"
#define APM_K_PRODUCT_IMAGES            @"images"
#define APM_K_PRODUCT_REVIEWS           @"reviews"
#define APM_K_PRODUCT_COLORS            @"colors"
#define APM_K_PRODUCT_SIZES             @"sizes"
#define APM_K_PRODUCT_VARIANTS          @"variants"
#define APM_K_PRODUCT_LINKS             @"links"

@interface APMProduct : APMModel<NSCoding, NSCopying>

@property (nonatomic, assign) NSInteger identifiant;
@property (nonatomic, strong) NSString* ean;
@property (nonatomic, strong) NSString* ref;
@property (nonatomic, strong) NSString* url;
@property (nonatomic, strong) NSString* lang;
@property (nonatomic, strong) NSString* title;
@property (nonatomic, strong) NSString* price;
@property (nonatomic, strong) NSString* discountedPrice;
@property (nonatomic, strong) NSString* discount;
@property (nonatomic, strong) NSString* currency;
@property (nonatomic, strong) NSString* desc;
@property (nonatomic, strong) NSString* shortDescription;
@property (nonatomic, assign) double rating;
@property (nonatomic, assign) NSInteger ratingScale;
@property (nonatomic, assign) NSInteger colorId;
@property (nonatomic, assign) NSInteger sizeId;
@property (nonatomic, assign) NSInteger availability;

@property (nonatomic, strong) NSArray* videos;
@property (nonatomic, strong) NSArray* images;
@property (nonatomic, strong) NSArray* reviews;
@property (nonatomic, strong) NSArray* colors;
@property (nonatomic, strong) NSArray* sizes;
@property (nonatomic, strong) NSArray* variants;
@property (nonatomic, strong) NSDictionary* links;

-(id)initWithJSONObject:(NSDictionary*)jsonObject;
-(NSInteger)selectedSizeIndex;
-(NSInteger)selectedColorIndex;

@end
