//
//  APMProductAttribute.h
//  APMServices
//
//  Created by Vincent Ducastel on 11/09/2018.
//  Copyright (c) 2018 Moonmiles. All rights reserved.
//

#import "APMModel.h"

@class APMImage;

#define APM_K_PRODUCT_ATTRIBUTE_AVAILABILITY_UNAVAILABLE 0
#define APM_K_PRODUCT_ATTRIBUTE_AVAILABILITY_AVAILABLE 1

#define APM_K_PRODUCT_ATTRIBUTE_ID @"id"
#define APM_K_PRODUCT_ATTRIBUTE_NAME @"name"
#define APM_K_PRODUCT_ATTRIBUTE_RESOURCE_URL @"resourceUrl"
#define APM_K_PRODUCT_ATTRIBUTE_IMAGE @"image"
#define APM_K_PRODUCT_ATTRIBUTE_AVAILABILITY @"availability"

@interface APMProductAttribute : APMModel<NSCoding, NSCopying>

@property (nonatomic, assign) NSInteger identifiant;
@property (nonatomic, strong) NSString* name;
@property (nonatomic, strong) APMImage* image;
@property (nonatomic, assign) NSInteger availability;

-(id)initWithJSONObject:(NSDictionary*)jsonObject;
-(BOOL)isAvailable;

@end
