//
//  APMRule.h
//  APMServices
//
//  Created by Vincent Ducastel on 11/09/2018.
//  Copyright (c) 2018 Moonmiles. All rights reserved.
//

#import "APMModel.h"

#define APM_K_RULE_ID                           @"id"
#define APM_K_RULE_ELIGIBILITY                  @"generosityEligibility"
#define APM_K_RULE_GENEROSITY_OFFSET            @"generosityOffset"
#define APM_K_RULE_TRIGGERED_AT                @"triggeredAt"
#define APM_K_RULE_FILTERS                      @"filters"

#define APM_RULE_ELIGIBILITY_OFF 0
#define APM_RULE_ELIGIBILITY_ON 1

@interface APMRule : APMModel<NSCoding, NSCopying>

@property (nonatomic, assign) NSInteger identifiant;
@property (nonatomic, assign) NSInteger eligibility;
@property (nonatomic, assign) double frequencyOffset;
@property (nonatomic, strong) NSDate* triggeredAt;
@property (nonatomic, strong) NSArray* filters;

-(id)initWithJSONObject:(NSDictionary*)jsonObject;
-(BOOL)isPlayable;

@end
