//
//  APMServicesDataUtils.h
//  APMServices
//
//  Created by Vincent Ducastel on 08/11/2016.
//  Copyright © 2016 Moonmiles. All rights reserved.
//

@interface APMServicesDataUtils : NSObject

#pragma mark - JSON

+(BOOL)jsonObject:(NSDictionary*)jsonObject boolForKey:(NSString*)key defaultValue:(BOOL)defaultValue;
+(NSInteger)jsonObject:(NSDictionary*)jsonObject integerForKey:(NSString*)key defaultValue:(NSInteger)defaultValue;
+(double)jsonObject:(NSDictionary*)jsonObject doubleForKey:(NSString*)key defaultValue:(double)defaultValue;
+(id)jsonObject:(NSDictionary*)jsonObject objectForKey:(NSString*)key defaultValue:(id)defaultValue;
+(id)jsonObject:(NSDictionary*)jsonObject numberForKey:(NSString*)key defaultValue:(NSNumber*)defaultValue;
+(id)jsonObject:(NSDictionary*)jsonObject arrayForKey:(NSString*)key defaultValue:(id)defaultValue class:(Class)class;
+(NSDate*)jsonObject:(NSDictionary*)jsonObject dateForKey:(NSString*)key defaultValue:(id)defaultValue dateFormat:(NSString*)dateFormat;
+(NSDate*)jsonObject:(NSDictionary*)jsonObject dateTimestampForKey:(NSString*)key defaultValue:(id)defaultValue;

#pragma mark - NSUserDefaults

+(NSInteger)integerValueForKey:(NSString*)key defaultValue:(NSInteger)defaultValue;
+(void)setIntegerValue:(NSInteger)value forkey:(NSString*)key;
+(BOOL)boolValueForKey:(NSString*)key defaultValue:(BOOL)defaultValue;
+(void)setBoolValue:(BOOL)value forkey:(NSString*)key;
+(void)removeKey:(NSString*)key;

#pragma mark - Others

+(BOOL)valueNotNull:(id)value;
+(BOOL)stringNotEmpty:(NSString*)value;

@end
