//
//  APMServicesPageUtils.h
//  APMServices
//
//  Created by Vincent Ducastel on 31/05/2017.
//  Copyright © 2017 Moonmiles. All rights reserved.
//


#define APM_PAGE_RUBRIC_HOW_IT_WORKS 1
#define APM_PAGE_RUBRIC_ONBOARDING   2

@interface APMServicesPageUtils : NSObject

@property(nonatomic, strong) NSMutableArray *howWorks;
@property(nonatomic, strong) NSMutableArray *onboarding;

+(APMServicesPageUtils *)sharedInstance;
-(void)initInstance;

-(NSMutableArray*)getPagesWithRubric:(NSInteger)rubric;
-(NSMutableArray*)getPagesWithRubric:(NSInteger)rubric userConnected:(BOOL)userConnected;
-(BOOL)canShowPages:(NSInteger)rubric;
-(BOOL)canShowPages:(NSInteger)rubric userConnected:(BOOL)userConnected;
-(BOOL)pagesExists:(NSInteger)rubric;
-(void)savePagesViewed:(NSInteger)rubric;
-(void)savePagesViewed:(NSInteger)rubric userConnected:(BOOL)userConnected;
-(BOOL)isViewedWithPages:(NSMutableArray*)pages;
-(NSInteger)nbViewWithPages:(NSArray*)pages;
-(void)successPagesWithRubric:(NSInteger)rubric result:(NSDictionary*)result;
-(void)removePages:(NSInteger)rubric;
-(void)resetAll;

@end
