//
//  APMTrophy.h
//  APMServices
//
//  Created by Vincent Ducastel on 09/01/2017.
//  Copyright © 2017 Moonmiles. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "APMModel.h"

#define APM_K_TROPHY_ID                        @"id"
#define APM_K_TROPHY_LABEL                     @"label"
#define APM_K_TROPHY_DESC                      @"description"
#define APM_K_TROPHY_CURRENT_STEP              @"currentStep"
#define APM_K_TROPHY_TOTAL_STEP                @"totalStep"
#define APM_K_TROPHY_GENEROSITIES              @"generosities"
#define APM_K_TROPHY_TRIGGERED_AT              @"triggeredAt"
#define APM_K_TROPHY_ILLUS_ON                  @"illusOn"
#define APM_K_TROPHY_ILLUS_OFF                 @"illusOff"
#define APM_K_TROPHY_TYPE                      @"type"
#define APM_K_TROPHY_TYPE_DEFAULT              0
#define APM_K_TROPHY_TYPE_MYSTERY              1
#define APM_K_TROPHY_TYPE_INDIVIDUAL           2
#define APM_K_TROPHY_IS_RECENTLY_COMPLETED     @"isRecentlyCompleted"

@interface APMTrophy : APMModel<NSCoding, NSCopying>

@property(nonatomic, assign) NSInteger identifiant;
@property(nonatomic, strong) NSString *label;
@property(nonatomic, strong) NSString *desc;
@property(nonatomic, assign) NSInteger currentStep;
@property(nonatomic, assign) NSInteger totalStep;
@property(nonatomic, strong) NSMutableArray *generosities;
@property(nonatomic, strong) NSDate *triggeredAt;
@property(nonatomic, strong) NSString *illusOn;
@property(nonatomic, strong) NSString *illusOff;
@property(nonatomic, assign) NSInteger type;

//Local
@property(nonatomic, assign) BOOL isRecentlyCompleted;

-(instancetype)initWithJSONObject:(NSDictionary*)jsonObject;
-(void)updateWithTrophy:(APMTrophy*)trophy;
-(BOOL)isDone;
-(BOOL)isMystery;
-(BOOL)isIndividual;

@end
