//
//  APMUserJourney.h
//  APMServices
//
//  Created by Vincent Ducastel on 09/01/2017.
//  Copyright © 2017 Moonmiles. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "APMModel.h"

@class APMUser;

#define APM_K_USER_JOURNEY_USER_STATUS                                  @"status"
#define APM_K_USER_JOURNEY_USER_STATUS_UPDATED_AT                       @"statusUpdatedAt"
#define APM_K_USER_JOURNEY_CATEGORIES_TROPHIES                          @"categories"
#define APM_K_USER_JOURNEY_CATEGORIES_TROPHIES_JOURNEY_UPDATED_AT       @"categoriesUpdatedAt"

@interface APMUserJourney : APMModel<NSCoding, NSCopying>

@property(nonatomic, strong) NSMutableArray *userStatuses;
@property(nonatomic, strong) NSDate *userStatusesUpdatedAt;
@property(nonatomic, strong) NSMutableArray *categoriesTrophy;
@property(nonatomic, strong) NSDate *categoriesTrophyJourneyUpdatedAt;

-(instancetype)initWithJSONObject:(NSDictionary*)jsonObject;

-(void)updateWithJSONObject:(NSDictionary*)jsonObject;
-(void)copyStatusWithUserJourney:(APMUserJourney*)userJourney;
-(void)copyTrophiesWithUserJourney:(APMUserJourney*)userJourney;

@end
