//
//  APMWalkthrough.h
//  APMServices
//
//  Created by Vincent Ducastel on 08/01/2015.
//  Copyright (c) 2015 Moonmiles. All rights reserved.
//

#import "APMModel.h"

@class APMUser;

@interface APMWalkthrough : APMModel<NSCoding, NSCopying>

@property(nonatomic, assign) NSInteger identifiant;
@property(nonatomic, strong) NSString *label;
@property(nonatomic, strong) NSString *content;
@property(nonatomic, assign) NSInteger threshold;
@property(nonatomic, assign) NSInteger delay;
@property(nonatomic, assign) NSInteger target; //0 : Not connected, 1 : Connected, 2 : Connected and not connected
@property(nonatomic, assign) BOOL clearable;
@property(nonatomic, assign) NSInteger status; //0 : Offline, 1 : Online

@property(nonatomic, strong) NSDate *viewedAt;
@property(nonatomic, assign) NSInteger count;

-(instancetype)initWithJSONObject:(NSDictionary*)jsonObject;
-(BOOL)isViewed;
-(BOOL)isViewableForUser:(APMUser*)user;
-(BOOL)isOnline;

@end
